/**
 * DevExtreme (bundles/__internal/scheduler/shaders/m_current_time_shader.js)
 * Version: 23.2.3 (build 24011-0114)
 * Build date: Thu Jan 11 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = void 0;
var _renderer = _interopRequireDefault(require("../../../core/renderer"));

function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    }
}
const DATE_TIME_SHADER_CLASS = "dx-scheduler-date-time-shader";
let CurrentTimeShader = function() {
    function CurrentTimeShader(_workSpace) {
        this._workSpace = _workSpace;
        this._$container = this._workSpace._dateTableScrollable.$content()
    }
    var _proto = CurrentTimeShader.prototype;
    _proto.render = function() {
        this.initShaderElements();
        this.renderShader();
        this._shader.forEach(shader => {
            this._$container.append(shader)
        })
    };
    _proto.initShaderElements = function() {
        this._$shader = this.createShader();
        this._shader = [];
        this._shader.push(this._$shader)
    };
    _proto.renderShader = function() {};
    _proto.createShader = function() {
        return (0, _renderer.default)("<div>").addClass(DATE_TIME_SHADER_CLASS)
    };
    _proto.clean = function() {
        this._$container && this._$container.find(".".concat(DATE_TIME_SHADER_CLASS)).remove()
    };
    return CurrentTimeShader
}();
var _default = CurrentTimeShader;
exports.default = _default;
