/**
 * DevExtreme (cjs/__internal/scheduler/appointments/m_render.js)
 * Version: 23.2.3 (build 24011-0114)
 * Build date: Thu Jan 11 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.renderAppointments = void 0;
var _renderer = _interopRequireDefault(require("../../../core/renderer"));
var _layout = _interopRequireDefault(require("../../../renovation/ui/scheduler/appointment/layout.j"));
var _m_utils = require("../m_utils");

function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    }
}
const renderAppointments = options => {
    const {
        instance: instance,
        $dateTable: $dateTable,
        viewModel: viewModel
    } = options;
    const container = getAppointmentsContainer($dateTable);
    _m_utils.utils.renovation.renderComponent(instance, container, _layout.default, "renovatedAppointments", viewModel)
};
exports.renderAppointments = renderAppointments;
const getAppointmentsContainer = $dateTable => {
    let container = (0, _renderer.default)(".dx-appointments-container");
    if (0 === container.length) {
        container = (0, _renderer.default)("<div>").addClass("dx-appointments-container").appendTo($dateTable)
    }
    return container
};
