/**
 * DevExtreme (cjs/ui/tabs/item.js)
 * Version: 23.2.3 (build 24011-0114)
 * Build date: Thu Jan 11 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";
exports.default = void 0;
var _renderer = _interopRequireDefault(require("../../core/renderer"));
var _item = _interopRequireDefault(require("../collection/item"));

function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    }
}
const TABS_ITEM_BADGE_CLASS = "dx-tabs-item-badge";
const BADGE_CLASS = "dx-badge";
const TabsItem = _item.default.inherit({
    _renderWatchers: function() {
        this.callBase();
        this._startWatcher("badge", this._renderBadge.bind(this))
    },
    _renderBadge: function(badge) {
        this._$element.children(".dx-badge").remove();
        if (!badge) {
            return
        }
        const $badge = (0, _renderer.default)("<div>").addClass("dx-tabs-item-badge").addClass("dx-badge").text(badge);
        this._$element.append($badge)
    }
});
var _default = TabsItem;
exports.default = _default;
module.exports = exports.default;
module.exports.default = exports.default;
